# Docker Compose: PostgreSQL, RabbitMQ, Nginx

## Описание проекта

Этот проект разворачивает три сервиса с помощью Docker Compose:
1. **PostgreSQL** — реляционная база данных.
2. **RabbitMQ** — брокер сообщений с панелью управления.
3. **Nginx** — веб-сервер и реверс-прокси.


## Команды для запуска

Чтобы развернуть и запустить проект, выполните следующие шаги:
1. Убедитесь, что у вас установлен Docker и Docker Compose.
2. Перейдите в директорию с файлом docker-compose.yml.
3. Запустите сервисы командой: docker-compose up --build

## Сервисы и порты
1. **PostgreSQL:**  
   **Порт:** 5432  
   **Доступ:** Локально, через любые приложения, подключающиеся к базе данных PostgreSQL.


2. **RabbitMQ:**  
   **Порт для приложений:** 5672  
   **Панель управления RabbitMQ:** Доступна по адресу [http://localhost:15672/](http://localhost:15672/) (логин: `user`, пароль: `password`).


3. **Nginx:**  
   **Порт:** 80  
   **Назначение:** Используется как реверс-прокси для распределения трафика.

## Видео https://drive.google.com/file/d/1qzc_IFZBFkUVGJ97bkcsKpbwn8pw3Hay/view